#include "NewsServer.h"
#include <Zeit.h>
#include <iostream>
#include <fstream>
#include <Globals.h>

int main()
{
    Framework::initFramework();
	Zeit *z = getZeit();
	Text *pfad = new Text( "../log/news/" );
	pfad->append( z->getZeit( "y-m-d h-i-s.log" ) );
	z->release();
	DateiPfadErstellen( pfad->getThis() );
	std::ofstream file;
	file.open( pfad->getText() );
	std::streambuf* sbuf = std::cout.rdbuf();
	std::cout.rdbuf( file.rdbuf() );
	pfad->release();

	std::cout << "NS: Startet...\n";
	std::cout << "NS: Lese init Datei ../data/nsInit.ini ...\n";
	InitDatei *dat = new InitDatei( "../data/nsInit.ini" );
	if( !dat->laden() )
	{
		std::cout << "NS: error: Datei konnte nicht gelesen werden. Das Programm wird geschlossen.\n";
		dat->release();
		exit( 1 );
	}
    const char *wichtig[] = { "ServerId", "DBBenutzer", "DBPasswort", "DBName", "DBIP", "DBPort", "Aktiv" };
    for( const char *w : wichtig )
    {
        if( !dat->wertExistiert( w ) )
        {
            std::cout << "NS: error: Der Wert '" << w << "' wurde nicht gefunden. Das Programm wird geschlossen.\n";
            dat->release();
            exit( 1 );
        }
    }

	NewsServer *nServer = new NewsServer( dat );

	std::cout << "NS: Der Admin Server läuft. Startforgang beendet.\n";
	nServer->runn();

	nServer->ende();
	nServer->release();
	dat->release();
	std::cout << "NS: Der Server ist heruntergefahren.\n";
	file.close();
	std::cout.rdbuf( sbuf );
    Framework::releaseFramework();
	return 0;
}